<?php
class DB {
   /* -------------------------------------------------------------------------- 
   		Connect/disconnect/Create Spunk-Database!   
   ----------------------------------------------------------------------------- */     
   function DB() 
   {
       $host = "localhost";
       $db   = "spunk";
       $user = "root";
       $pass = ""; 

       $this->link = mysql_connect($host, $user, $pass);
       if (!$this->link)  {die('Error message: ' . mysql_error());}            
       $db_selected = mysql_select_db($db);
       if (!$db_selected)
       {
        $this->create_db_structure();
        $db_selected = mysql_select_db($db);
        if (!$db_selected){die('Error message: ' . mysql_error());}
       }
   }
   
   function close() 
   {
       mysql_close($this->link);
   }
   
   
   function create_db_structure()
   {
   $this->query("CREATE DATABASE spunk DEFAULT CHARACTER SET latin1 COLLATE latin1_general_ci");
   $this->query("USE spunk");   
   
   $this->query("CREATE TABLE `c64_disk` (
      `disk_id` int(11) NOT NULL auto_increment,
      `disk_md5` varchar(32) collate latin1_general_ci NOT NULL,
      `disk_dir_md5` varchar(32) collate latin1_general_ci NOT NULL,
      `disk_label` varchar(24) collate latin1_general_ci NOT NULL default '',
      `disk_comment` varchar(255) collate latin1_general_ci NOT NULL,
      `disk_archive_type` varchar(5) collate latin1_general_ci NOT NULL default '',
       PRIMARY KEY  (`disk_id`),
       KEY `disk_md5` (`disk_md5`),
       KEY `disk_dir_md5` (`disk_dir_md5`),
       KEY `disk_label` (`disk_label`),
       KEY `disk_archive_type` (`disk_archive_type`)
      ) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;");
   
   $this->query("
      CREATE TABLE `c64_file` (
      `file_id` int(11) NOT NULL auto_increment,
      `file_entry` varchar(24) collate latin1_general_ci NOT NULL default '',
      `file_entry_md5` varchar(32) collate latin1_general_ci NOT NULL,
      `file_type` varchar(6) collate latin1_general_ci NOT NULL default '',
      `file_size` int(3) NOT NULL default '0',
      `file_comment` varchar(100) collate latin1_general_ci NOT NULL default '',
      `disk_id` int(11) NOT NULL default '0',
      PRIMARY KEY  (`file_id`),
      KEY `file_entry` (`file_entry`,`file_type`,`file_size`,`disk_id`),
      KEY `file_entry_md5` (`file_entry_md5`),
      KEY `disk_id` (`disk_id`)
      ) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci; ");

    $this->query("
      CREATE TABLE `c64_pack` (
      `pack_id` int(11) NOT NULL auto_increment,
      `pack_name` varchar(255) collate latin1_general_ci NOT NULL default '',
      `pack_total_files` int(11) NOT NULL,
      `pack_date` datetime NOT NULL default '0000-00-00 00:00:00',
      PRIMARY KEY  (`pack_id`)
      ) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci; ");
   
    $this->query("
      CREATE TABLE `c64_relation_pack_disk` (
      `pack_id` int(11) NOT NULL,
      `disk_md5` varchar(32) collate latin1_general_ci NOT NULL,
      `disk_name` varchar(255) collate latin1_general_ci NOT NULL,
      `disk_reference` varchar(255) collate latin1_general_ci NOT NULL,
      KEY `pack_id` (`pack_id`),
      KEY `disk_md5` (`disk_md5`)
      ) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci; ");
   }

   function kill_spunk() 
   {
    $this->query(" DROP DATABASE spunk ");
   }

   
   /* -------------------------------------------------------------------------- 
     Database Query commands   
   ----------------------------------------------------------------------------- */
   
   function query($query) 
   {
       $result = mysql_query($query, $this->link);
       if (!$result) {die('Invalid query: ' . mysql_error());}      
       return $result;
   }
   

   function num_results($query)
   {
    return mysql_num_rows(mysql_query($query));  	
   }
   

   
   /* -------------------------------------------------------------------------- 
    *
    *  Search & Related functions
    *
   ----------------------------------------------------------------------------- */
   
   function retrieve_disk($disk_md5, $path)
   {
    /* GET INTERNAL FILE FUNCTION */  
    if ($disk_md5)
    {
      $get_file = mysql_fetch_array($this->get_disk_md5($disk_md5));
      $dname    = $get_file['disk_name'];
      $file     = $path.$get_file['disk_reference'].$dname;
    }
    else
    {
      $file  = str_replace("\'","",$path);
      $dname = basename($file);
    }
    
    if ( (file_exists($file)) AND is_file($file) )
    {
      header("Content-Disposition: attachment; filename=\"$dname\"");    
      header("Content-Type: application/octetstream");
      header("Content-Length: ".filesize($file)); 
      header("Cache-Control: no-cache, must-revalidate"); 
      header("Pragma: no-cache");
  
      $fp = fopen($file,"r");
      if ($fp===false){echo "Error opening file: $file <br><br>Please contact admin! ";}
      else{ echo fread( $fp, filesize($file) ); fclose($fp); exit();}
    }
    else
    {
      echo "<h2>File does not exist! Please contact admin!</h2>".$file."<br>";  
    }
   }
     
   
   function get_disk($disk_id)
   {
    $query = " 
      SELECT D.*, P.*, F.file_id, R.disk_name, R.disk_reference 
      FROM c64_disk AS D
      LEFT JOIN c64_file AS F ON F.disk_id=D.disk_id
      LEFT JOIN c64_relation_pack_disk AS R on R.disk_md5=D.disk_md5      
      LEFT JOIN c64_pack AS P ON P.pack_id=R.pack_id
      WHERE D.disk_id='$disk_id'
      GROUP BY disk_id 
    ";
    return mysql_query($query);
   }   


   function get_disk_md5($disk_md5)
   { 	
    $query = " 
      SELECT R.disk_name, R.disk_reference, D.* 
      FROM c64_relation_pack_disk AS R 
      LEFT JOIN c64_disk AS D ON D.disk_md5=R.disk_md5            
      WHERE R.disk_md5='$disk_md5' AND D.disk_md5='$disk_md5'
    ";   
    return mysql_query($query);
   }   


   function get_disk_dir_md5($disk_dir_md5)
   { 	
    $query = " 
      SELECT R.disk_name, R.disk_reference, D.*, P.* 
      FROM c64_relation_pack_disk AS R 
      LEFT JOIN c64_disk AS D ON D.disk_md5=R.disk_md5
      LEFT JOIN c64_pack AS P ON P.pack_id=R.pack_id            
      WHERE D.disk_dir_md5='$disk_dir_md5'
    ";   
    return mysql_query($query);
   }      
  
  
   function search($filename,$filetype=NULL,$filesize=NULL, $order=" ORDER BY file_entry, disk_dir_md5 ")
   {
    $filename = str_replace("%", "\\%", $filename);
    $filename = str_replace("", "%", $filename);
    $ftype="";
    if ($filetype){$ftype= " and file_type LIKE '$filetype' ";}
    if ($filesize){$ftype= " and file_size LIKE '$filesize' ";}  
  
    return mysql_query(" 
      SELECT F.*, R.disk_name, R.disk_reference, D.disk_dir_md5, D.disk_md5, D.disk_archive_type
      FROM c64_file as F
      LEFT JOIN c64_disk AS D ON D.disk_id=F.disk_id
      LEFT JOIN c64_relation_pack_disk AS R on R.disk_md5=D.disk_md5
      WHERE file_entry LIKE \"$filename\" $ftype $fsize  
      GROUP BY file_entry, disk_md5
      $order
      ");  
   }   

   function search_label($label)
   {
      $label = str_replace("%", "\\%", $label);
      $label = str_replace("", "%", $label);
      return mysql_query(" SELECT D.*, R.disk_name, R.disk_reference FROM c64_disk AS D LEFT JOIN c64_relation_pack_disk AS R on R.disk_md5=D.disk_md5 WHERE disk_label LIKE \"$label\" GROUP BY disk_md5 ORDER BY disk_label, disk_dir_md5 ");  
   } 
   
   function add_pack($pname)
   {
  	mysql_query(" INSERT INTO c64_pack (pack_name, pack_date) VALUES (\"$pname\", NOW()) ");
    return mysql_insert_id();     
   }

    
   function set_pack_files($number, $pack_id)
   {    
    mysql_query(" UPDATE c64_pack SET pack_total_files=\"$number\" WHERE pack_id='$pack_id' ");    
   }
   
   
  function delete_pack($pack_id)
  {
  	$pack_name = mysql_fetch_array(mysql_query(" SELECT pack_name FROM c64_pack WHERE pack_id='$pack_id' "), MYSQL_ASSOC);        
    
    // Delete all file_entries on each disk
    $disks  = $this->get_pack_uniquenes($pack_id, " ORDER BY D.disk_id ASC ", "=" );    
    $disk   = mysql_fetch_array($disks, MYSQL_ASSOC);
    $start  = $disk['disk_id'];
    $end    = $start;   
    while ($disk = mysql_fetch_array($disks))
  		  {
         if ($disk['disk_id']==($end+1)){$end++;}
         else
         {
             mysql_query(" DELETE FROM c64_file WHERE disk_id>='$start' AND disk_id<='$end' ");
             mysql_query(" DELETE FROM c64_disk WHERE disk_id>='$start' AND disk_id<='$end' ");
             $start = $disk['disk_id'];
             $end   = $start;
         }
        }
    mysql_query(" DELETE FROM c64_file WHERE disk_id>='$start' AND disk_id<='$end' ");
    mysql_query(" DELETE FROM c64_disk WHERE disk_id>='$start' AND disk_id<='$end' ");

    // Delete all relations and last the pack it self
  	mysql_query(" DELETE FROM c64_relation_pack_disk WHERE pack_id='$pack_id' ");        
  	mysql_query(" DELETE FROM c64_pack WHERE pack_id='$pack_id' ");

    // Detete rest of redundants of disks in this (all) pack.
    $disks = mysql_query(" SELECT disk_id FROM c64_disk AS D LEFT JOIN c64_relation_pack_disk AS R ON R.disk_md5=D.disk_md5 WHERE pack_id IS NULL ");
    while ($disk = mysql_fetch_array($disks, MYSQL_ASSOC))
    {      
      $disk_id = $disk['disk_id'];
      mysql_query(" DELETE FROM c64_file WHERE disk_id='$disk_id' ");
      mysql_query(" DELETE FROM c64_disk WHERE disk_id='$disk_id' ");
    }

    return $pack_name['pack_name'];
  } 
   
  function delete_all_packs()
  {
  	mysql_query(" TRUNCATE TABLE c64_disk "); 	
  	mysql_query(" TRUNCATE TABLE c64_file "); 	
  	mysql_query(" TRUNCATE TABLE c64_pack "); 	
  	mysql_query(" TRUNCATE TABLE c64_relation_pack_disk "); 	
  }


  function pack_name_exists($pack_name)
  {   
    return mysql_fetch_array(mysql_query(" SELECT * FROM c64_pack as P WHERE pack_name='$pack_name' "), MYSQL_ASSOC); 
  }


  function get_packs($pack_id=NULL, $disk_archive_type=', disk_archive_type')
   {
    $pack = ($pack_id) ? " WHERE p.pack_id='$pack_id' " : "";
    $query = " 
      SELECT Count(*) AS 'numOfFiles', P.*, disk_archive_type
      FROM c64_pack as P
      LEFT JOIN c64_relation_pack_disk AS R ON R.pack_id=P.pack_id
      LEFT JOIN c64_disk AS D ON D.disk_md5=R.disk_md5
      $pack
      GROUP BY pack_name $disk_archive_type
      ORDER BY pack_name 
    ";
  	return mysql_query($query);
   }      
   

  function get_pack_uniquenes($pack_id, $order_by=NULL, $operator='=')
  {
    // find disk_md5 that are unique in this packs. 
    $order = ($order_by==NULL) ? " " : " $order_by ";
    $query = " 
              SELECT count(*) AS 'antal', r1.disk_md5, D.disk_id, r2.pack_id 
              FROM c64_relation_pack_disk AS r1
              JOIN c64_relation_pack_disk AS r2 ON r1.disk_md5=r2.disk_md5 and r2.pack_id='$pack_id'
              LEFT JOIN c64_disk AS D ON D.disk_md5=r2.disk_md5
              GROUP BY disk_md5
              HAVING antal $operator 1
              $order  
    ";
    return mysql_query($query);
  }   
      

  function get_popular($count)
  {
    $query = " 
              SELECT count(*) AS 'antal', r1.disk_md5, D.disk_id, D.disk_label
              FROM c64_relation_pack_disk AS r1
              left join c64_disk AS D on D.disk_md5=r1.disk_md5
              GROUP BY disk_md5
              HAVING antal > '$count'
              ORDER BY antal DESC
              LIMIT 0,50
    ";
    return mysql_query($query);
  } 
   
   
  function add_disk(&$dname, &$dlabel, $dref, &$pack_id, $md5, $archive_type)
  {
   	mysql_query(" INSERT INTO c64_relation_pack_disk (pack_id, disk_md5, disk_name, disk_reference) 
                   VALUES (\"$pack_id\",  \"$md5\", \"$dname\", \"$dref\"  ) ");
    mysql_query(" INSERT INTO c64_disk (disk_label, disk_md5, disk_archive_type) VALUES (\"$dlabel\", \"$md5\",  \"$archive_type\") ");
    return mysql_insert_id(); // $disk_id
  }   
   

   function disk_md5_exist($md5hash, $add=NULL, $pack_id, &$dir_entry, $dir)
   {
    // add is for statistical info. e.g. how many of current md5 
    // disk has been tried to be added. 
    $row = mysql_fetch_array(mysql_query("SELECT disk_id FROM c64_disk as D WHERE D.disk_md5='$md5hash'"), MYSQL_ASSOC);
    $disk_id = $row['disk_id'];
    if (($add) AND ($disk_id) ){
      mysql_query(" INSERT INTO c64_relation_pack_disk (pack_id, disk_md5, disk_name, disk_reference) VALUES (\"$pack_id\",  \"$md5hash\",  \"$dir_entry\",  \"$dir\") ");
    }    
  	return $disk_id; 
   }   


   function file_entry_md5_exist($md5hash)
   {
    $row = mysql_fetch_array(mysql_query("SELECT disk_id FROM c64_file as F WHERE F.file_entry_md5='$md5hash'"), MYSQL_ASSOC);
  	return $row['disk_id']; 
   }


   function get_packname_disk_md5($md5hash)
   {
    $query = " 
      SELECT disk_reference, disk_name, pack_name
      FROM c64_relation_pack_disk AS RPD 
      LEFT JOIN c64_disk as D ON D.disk_md5=RPD.disk_md5
      LEFT JOIN c64_pack as P ON P.pack_id=RPD.pack_id
      WHERE D.disk_md5='$md5hash' 
      GROUP BY RPD.pack_id
    ";
    return mysql_query($query);        
  }


  function get_file_from_disk_md5($md5hash, $file_entry)
   {
    $file_entry = trim($file_entry);
    $query = " 
      SELECT disk_name, F.* 
      FROM c64_disk AS D
      LEFT JOIN c64_file as F ON F.disk_id=D.disk_id
      LEFT JOIN c64_relation_pack_disk AS R ON R.disk_md5=D.disk_md5
      WHERE D.disk_md5='$md5hash' AND file_entry LIKE \"%$file_entry%\"
    ";
    return @mysql_fetch_array(mysql_query($query), MYSQL_ASSOC);
  }

   
   function add_release(&$fentry, &$ftype, &$fsize, &$disk_id, $fmd5)
   {
    // only add file_entries with #chars>=2 that are [AZ-09]
    // If (preg_match("/[A-Z0-9]{2,}/",$fentry)) 
    $result = "";
    if (strlen(preg_replace('/[^A-Z0-9]/','',$fentry))>2)
    {
    $add    = true;
    $result = $fentry;
    if ($fmd5)
      {
        $row = mysql_fetch_array(mysql_query(" SELECT file_id FROM c64_file as F WHERE F.file_entry_md5='$fmd5' "), MYSQL_ASSOC);
        if ($row['file_id']) {$add = false;}
      }
      // Add release if fmd5=null or fmd5 does not exist.
      if ($add==true)
      {
  	    mysql_query(" INSERT INTO c64_file (file_entry, file_entry_md5, file_type, file_size, disk_id) 
                       VALUES (\"$fentry\", \"$fmd5\", \"$ftype\", \"$fsize\", \"$disk_id\") ");
  	  }
  	}
  	return $result;
   }  


   function add_release_array(&$Lfentry, &$Lftype, &$Lfsize, &$disk_id)
   {
    $dir_md5 = "";
    $values  = "";
    
    $size = sizeOf($Lfentry);
    for ($i=0;$i<$size;$i++){
      if ($Lftype[$i]=='PRG'){$dir_md5 .= $Lfentry[$i];}    
      $values .= "(\"".$Lfentry[$i]."\", \"".$Lftype[$i]."\", \"".$Lfsize[$i]."\", \"$disk_id\"),";
    }
    
    if ($values<>""){
      $values[strlen($values)-1] = ""; # remove last ',''
      mysql_query(" INSERT INTO c64_file (file_entry, file_type, file_size, disk_id) 
                    VALUES $values ");
  	  if ($dir_md5<>"") {$this->update_disk_dir_md5($disk_id, md5($dir_md5));}
    }    
   }


   function update_file($fid, $comment)
   {
    if (is_numeric($fid))
    {
      $cmt = htmlentities($comment);
      mysql_query(" UPDATE c64_file SET file_comment=\"$cmt\" WHERE file_id='$fid' ");    
  	}
   }


   function update_disk_dir_md5($did, $dir_md5)
   {
    if (is_numeric($did))
    {
      mysql_query(" UPDATE c64_disk SET disk_dir_md5=\"$dir_md5\" WHERE disk_id='$did' ");    
  	}
   }

   
   function export_comments()
   {
     $file = "export.sql";
     if (file_exists($file)){unlink($file);}
     
     $query = " SELECT file_entry, file_size, file_comment, D.disk_md5
                FROM c64_disk AS D
                LEFT JOIN c64_file AS F ON F.disk_id=D.disk_id
                LEFT JOIN c64_relation_pack_disk AS R on R.disk_md5=D.disk_md5              
                WHERE file_comment<>''
              ";

    $fp = fopen($file,"w");

    $SQLresult = mysql_query($query); 
    while ($row = mysql_fetch_array($SQLresult, MYSQL_ASSOC))
    {
      fwrite($fp, $row['disk_md5']." | ".$row['file_entry']." | ".$row['file_size']." | ".$row['file_comment']."\n");
    }
    fclose($fp);
    
    header("Content-Disposition: attachment; filename=\"comments_exportfile.spunk\"");
    header("Content-Type: application/octetstream");
    header("Content-Length: ".filesize($file)); 
    header("Cache-Control: no-cache, must-revalidate"); 
    header("Pragma: no-cache");
  
    $fp = fopen($file,"r");
    if ($fp===false){echo "Error opening file: $file <br><br>Please contact admin! ";}
    else{ echo fread( $fp, filesize($file) ); fclose($fp); exit();}    
   }
   
   
   function import_comment($md5hash, $file_entry, $file_size, $comment)
   {
    $imported = 0;
    $disk_id = $this->disk_md5_exist($md5hash, null, null, $imported, null);
    if ($disk_id)
    {
     mysql_query(" UPDATE c64_file SET file_comment=\"$comment\" WHERE disk_id='$disk_id' AND file_size='$file_size' AND file_entry='$file_entry' ");    
     $imported = 1;
    }
    return $imported;
   }
   
   function count_comments()
   {
      $row = mysql_fetch_row(mysql_query(" SELECT count(*) FROM c64_file WHERE file_comment<>'' "));
      return $row[0];
   }
   
   
   // -------------------------------------------------------------------------
   // the END.   
   // -------------------------------------------------------------------------
} 
